#ifndef CFlatDisplayInformation_H
#define CFlatDisplayInformation_H

#include <xmdv/CScreenDistortion.h>
#include <xmdv/colorassign.h>

enum GLYPH_PLACE_MODE { 
	ORIGINAL,
    ORDERED,
    DATA_DRIVEN,
    DERIVED
};

class CFlatDisplayInformation
{
public:
    //for glyph placement
	GLYPH_PLACE_MODE glyph_place;
    int xdimension;
    int ydimension;
    int increase;
    int space;
    int reduce_overlap;

    //for color setting
    colorassign colorassigned;
    char colorscale[100];

    //for glyph shape
    int glyphShape;

    //for time series animation
    int time_dim;
    double current_time;
    double time_window_width;
    bool time_series_animation;
    int time_method;

    //for Flat Structure-based brush
    bool flat_sb_brush;
    bool redraw;


public:
	CFlatDisplayInformation();
	~CFlatDisplayInformation();
    void Reset();
    void Shape_Original_Glyph();
    void Shape_New_Glyph();

};


#endif
