//modified by Jing Yang after 7/6/2001
#include <xmdv/InterRing/CInterRingDataClusterTree.h>
#include <xmdv/InterRing/CInterRingDataCluster.h>
#include <stdio.h>
#include <xmdv/XmdvTool.h>
#include <string.h>

CInterRingDataClusterTree::CInterRingDataClusterTree() : CInterRingClusterTree()
{
}


CInterRingDataClusterTree::~CInterRingDataClusterTree()
{

}

//contrucst the data cluster tree, can't work if the data hierarchy (btree) is not in the main memory
bool CInterRingDataClusterTree::ConstructTree()
{
    if ( !dataset )
        return false;

    if ( !btree )
        hierInitClusterTree();

    if ( !btree )
        return false;

    int i; 

    // Get tree size
    int num_nodes;
    num_nodes = btree->nodes.Len();
    
    // Allocate space for all node pointers and parent_ids;
    //
    ARR<CInterRingCluster *> nodes;
	ARR<int> parent_ids;

	nodes.SetLen(num_nodes);
    parent_ids.SetLen(num_nodes);

	for ( i = 0; i < num_nodes; i++ )
	{
		nodes[i] = NULL;
		parent_ids[i] = -2;
	}

    char temp_name[300];
	for( i = 0; i < num_nodes; i++)
	{
		sprintf(temp_name, "node%1d", i);
        nodes[i] = new CInterRingDataCluster();
        nodes[i]->name = new char[strlen(temp_name)+1];
        strcpy(nodes[i]->name, temp_name);
        ((CInterRingDataCluster *)nodes[i])->data_node = &(btree->nodes[i]);
        nodes[i]->entries = btree->nodes[i].entries;
        parent_ids[i] = btree->nodes[i].parent;
	}
    
	//construct the dim cluster tree according to the arrays;
	if ( ConstructInterRingClusterTree(num_nodes, nodes, parent_ids) )
    {
        return true;
    }
    else
    {
        return false;
    }
}


void CInterRingDataClusterTree::ResetNames()
{
//to be done	((CInterRingDimCluster *)root)->ResetNames();
}

void CInterRingDataClusterTree::ResetSelection()
{
}